Bug 502227 - (virtuoso-opensource) Review Request: virtuoso-opensource - A high-performance object-relational SQL database
Review Request: virtuoso-opensource - A high-performance object-relational SQ...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Lorenzo Villani
Fedora Extras Quality Assurance
:
Depends On: 504076
Blocks:
  Show dependency treegraph
 
Reported: 2009-05-22 12:29 EDT by Rex Dieter
Modified: 2011-01-13 12:21 EST (History)
6 users (show)

See Also:
Fixed In Version: 5.0.11-3.fc10
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-07-26 16:34:35 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
lorenzo: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Rex Dieter 2009-05-22 12:29:49 EDT
Spec URL: http://rdieter.fedorapeople.org/rpms/virtuoso-opensource/virtuoso-opensource.spec
SRPM URL: http://rdieter.fedorapeople.org/rpms/virtuoso-opensource/virtuoso-opensource-5.0.11-1.src.rpm
Description:
Virtuoso is a scalable cross-platform server that combines SQL/RDF/XML
Data Management with Web Application Server and Web Services Platform
functionality.

Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=1370877
Comment 1 Susi Lehtola 2009-05-24 13:33:07 EDT
URL is obsolete, should be http://virtuoso.openlinksw.com/dataspace/dav/wiki/Main/
Comment 2 Rex Dieter 2009-05-24 14:40:09 EDT
meh, it's a redirect to a wiki (which I'd venture could very well change).
Comment 3 Ben Boeckel 2009-05-26 15:12:14 EDT
Looks good to me. There's some trailing whitespace in the spec file (Version and Source0 lines), but not a showstopper. Changelog is missing release. rpmlint output:

% rpmlint *.rpm
virtuoso-opensource.src: W: mixed-use-of-spaces-and-tabs (spaces: line 6, tab: line 1)                                                                            
virtuoso-opensource.x86_64: W: incoherent-version-in-changelog 5.0.11 ['5.0.11-1.fc11', '5.0.11-1']
virtuoso-opensource.x86_64: E: invalid-soname /usr/lib64/virtodbc.so virtodbc.so
virtuoso-opensource.x86_64: W: shared-lib-calls-exit /usr/lib64/virtodbc.so exit@GLIBC_2.2.5
virtuoso-opensource.x86_64: E: invalid-soname /usr/lib64/virtodbcu.so virtodbcu.so
virtuoso-opensource.x86_64: W: shared-lib-calls-exit /usr/lib64/virtodbcu.so exit@GLIBC_2.2.5
virtuoso-opensource.x86_64: E: invalid-soname /usr/lib64/virtodbc_r.so virtodbc_r.so
virtuoso-opensource.x86_64: W: shared-lib-calls-exit /usr/lib64/virtodbc_r.so exit@GLIBC_2.2.5
virtuoso-opensource.x86_64: E: invalid-soname /usr/lib64/virtodbcu_r.so virtodbcu_r.so
virtuoso-opensource.x86_64: W: shared-lib-calls-exit /usr/lib64/virtodbcu_r.so exit@GLIBC_2.2.5
virtuoso-opensource.x86_64: W: dangling-relative-symlink /var/lib/virtuoso/db/virtuoso.ini ../../..//etc/virtuoso/virtuoso.ini
virtuoso-opensource-apps.x86_64: W: no-documentation
virtuoso-opensource-conductor.noarch: W: no-documentation
virtuoso-opensource-debuginfo.x86_64: W: spurious-executable-perm /usr/src/debug/virtuoso-opensource-5.0.11/libsrc/Wi/xmllazy.c
virtuoso-opensource-debuginfo.x86_64: W: spurious-executable-perm /usr/src/debug/virtuoso-opensource-5.0.11/libsrc/Wi/sparqld.c
virtuoso-opensource-utils.x86_64: W: no-documentation
6 packages and 0 specfiles checked; 4 errors, 12 warnings.
Comment 4 Kevin Kofler 2009-05-26 16:49:03 EDT
We also need libiodbc from http://www.iodbc.org/ packaged, it's used by Soprano to communicate with Virtuoso.
Comment 5 Kevin Kofler 2009-06-04 11:31:20 EDT
iodbc review request: https://bugzilla.redhat.com/show_bug.cgi?id=504076
Comment 6 Lorenzo Villani 2009-06-07 12:22:55 EDT
#########################################
# MUST ITEMS
#########################################


--> rpmlint must be run on every package. The output should be posted in the review.
    Status: *** FAIL ***
    Additional comments: [lvillani@enterprise i386]$ rpmlint *.rpm
virtuoso-opensource.i586: W: incoherent-version-in-changelog 5.0.11 ['5.0.11-1.fc11', '5.0.11-1']
virtuoso-opensource.i586: E: invalid-soname /usr/lib/virtodbcu_r.so virtodbcu_r.so
virtuoso-opensource.i586: W: shared-lib-calls-exit /usr/lib/virtodbcu_r.so exit@GLIBC_2.0
virtuoso-opensource.i586: E: invalid-soname /usr/lib/virtodbcu.so virtodbcu.so
virtuoso-opensource.i586: W: shared-lib-calls-exit /usr/lib/virtodbcu.so exit@GLIBC_2.0
virtuoso-opensource.i586: E: invalid-soname /usr/lib/virtodbc.so virtodbc.so
virtuoso-opensource.i586: W: shared-lib-calls-exit /usr/lib/virtodbc.so exit@GLIBC_2.0
virtuoso-opensource.i586: E: invalid-soname /usr/lib/virtodbc_r.so virtodbc_r.so
virtuoso-opensource.i586: W: shared-lib-calls-exit /usr/lib/virtodbc_r.so exit@GLIBC_2.0
virtuoso-opensource.i586: W: dangling-relative-symlink /var/lib/virtuoso/db/virtuoso.ini ../../..//etc/virtuoso/virtuoso.ini
virtuoso-opensource-apps.i586: W: no-documentation
virtuoso-opensource-conductor.noarch: W: no-documentation
virtuoso-opensource-utils.i586: W: no-documentation
4 packages and 0 specfiles checked; 4 errors, 9 warnings.

From the %changelog:
* Fri May 22 2009 Rex Dieter <rdieter@fedoraproject.org> 5.0.11
this should be 5.0.11-1

virtuoso-opensource.i586: W: shared-lib-calls-exit /usr/lib/virtodbcu_r.so exit@GLIBC_2.0
I don't know how to deal with that but I guess it can be ignored

virtuoso-opensource.i586: E: invalid-soname /usr/lib/virtodbcu_r.so virtodbcu_r.so
Kevin told me that this isn't a showstopper since these libraries should be dlopened and not linked. However, I think it's better to ask upstream to move these libraries off %_libdir

To sum up:
- The changelog issue must be fixed
- shared-lib-calls-exit -> This is a problem in their code but I don't think it's a showstopper
- invalid-soname -> This is not a showstopper but ping upstream, if possible, and ask them to change the path in a future release
- no-documentation in subpackages -> Not a problem



--> The package must be named according to the  Package Naming Guidelines
    Status: PASS



--> The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
    Status: PASS



--> The package must meet the  Packaging Guidelines
    Status: PASS



--> The package must be licensed with a Fedora approved license and meet the  Licensing Guidelines.
    Status: PASS
    Additional comments: Package license is GPL2 and the exemptions seems acceptable to me.



--> The License field in the package spec file must match the actual license.
    Status: PASS



--> If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
    Status: PASS



--> The spec file must be written in American English.
    Status: PASS



--> The spec file for the package MUST be legible.
    Status: PASS



--> The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the  Source URL Guidelines for how to deal with this.
    Status: PASS



--> The package MUST successfully compile and build into binary rpms on at least one primary architecture.
    Status: PASS
    Additional comments: The scratch build shows that it builds on all supported architectures



--> If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
    Status: PASS



--> All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
    Status: PASS



--> The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
    Status: PASS



--> Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker default paths, must call ldconfig in %post and %postun.
    Status: PASS
    Additional comments: The package seems to install only dlopen'ed files, I guess there's no need to run ldconfig



--> If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
    Status: PASS



--> A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
    Status: *** FAIL ***
    Additional comments: The main package owns an empty directory: %{_libdir}/virtuoso
The -apps subpackage creates %{_libdir}/virtuoso/hosting
I suggest that only the -apps subpackage get ownership on that directory

I guess that a similar approach could be applied to %_datadir/virtuoso/vad



--> A Fedora package must not list a file more than once in the spec file's %files listings.
    Status: PASS



--> Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
    Status: PASS



--> Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
    Status: PASS



--> Each package must consistently use macros.
    Status: PASS



--> The package must contain code, or permissable content.
    Status: PASS



--> Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
    Status: *** FAIL ***
    Additional comments: It seems there's plenty of documentation in docsrc subdirectory but you're not shipping it.



--> If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
    Status: PASS



--> Header files must be in a -devel package.
    Status: PASS



--> Static libraries must be in a -static package.
    Status: PASS



--> Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability).
    Status: PASS



--> If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package.
    Status: PASS
    Additional comments: This package seems to not contain linkable libraries



--> In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}
    Status: PASS



--> Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
    Status: *** FAIL ***
    Additional comments: %_libdir/virtuoso/hosting contains creolewiki.la mediawiki.la and wikiv.la files



--> Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
    Status: PASS



--> Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time.
    Status: PASS



--> At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
    Status: PASS



--> All filenames in rpm packages must be valid UTF-8.
    Status: PASS



#########################################
# SHOULD ITEMS
#########################################


--> If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
    Status: PASS



--> The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
    Status: PASS



--> The reviewer should test that the package builds in mock.
    Status: PASS



--> The package should compile and build into binary rpms on all supported architectures.
    Status: PASS
    Additional comments: The scratch build confirms that it builds on all supported architectures



--> The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
    Status: PASS
    Additional comments: A quick test showed that the main executable work.



--> If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
    Status: PASS



--> Usually, subpackages other than devel should require the base package using a fully versioned dependency.
    Status: PASS



--> The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
    Status: PASS



Generated with reviewtool 0.0.1
Comment 7 Rex Dieter 2009-06-07 17:43:57 EDT
Spec URL:
http://rdieter.fedorapeople.org/rpms/virtuoso-opensource/virtuoso-opensource.spec
SRPM URL:
http://rdieter.fedorapeople.org/rpms/virtuoso-opensource/virtuoso-opensource-5.0.11-2.src.rpm

* Sun Jun 07 2009 Rex Dieter <rdieter@fedoraproject.org> 5.0.11-2
- omit remaining .la files
- fix %%changelog
- fix virtuoso.ini dangling symlink
Comment 8 Rex Dieter 2009-06-18 14:15:57 EDT
ping, are there any remaining review blockers?  did I miss anything?
Comment 9 Lorenzo Villani 2009-06-19 10:07:49 EDT
Did you fix directory ownership?

Side notes: until 9 or 10th of July it's "exams time" for me.. Maybe I should step back and allow another reviewer to complete the review?
Comment 10 Rex Dieter 2009-06-22 09:35:39 EDT
OK, I see now.

I would disagree here, and would argue the best place for ownership of 
%_libdir/virtuoso
is in the main package.  

Currently, both -apps and -conductor use this, and they don't depend on each other, and I don't consider it a better solution to have each of them own it.  Further, it's safer to have the main pkg own this, in case there are ever more pkgs (subpkgs of this one, or others) that need drop stuff in there.
Comment 11 Lorenzo Villani 2009-06-29 16:31:31 EDT
Issues are fixed.

I agree with you regarding directory ownership so this isn't an issue anymore.

There's just one MUST item left: the -doc subpkg.
Virtuoso has lot of stuff in docsrc/ and HTML pages can be generated out of it. I suggest to generate just the HTML and package in a -doc subpackage.
Comment 12 Kevin Kofler 2009-07-22 09:24:37 EDT
I guess this isn't so high priority anymore as the Soprano Virtuoso backend has been postponed to at least KDE 4.4. :-( They dropped it from the Soprano 2.3 branch as not ready. We could ship it from trunk, but it's reported not to work at the moment (regressions with the latest Virtuoso, apparently).
Comment 13 Rex Dieter 2009-07-22 09:37:07 EDT
Yeah, what Kevin said.  Personally, I plan on waiting until soprano supports it again, unless there's interest or reason to do otherwise.
Comment 14 Lorenzo Villani 2009-07-22 10:52:37 EDT
Is setting CLOSED: DEFERRED a good idea?
Comment 15 Rex Dieter 2009-07-24 09:37:12 EDT
I'll try to take care of it soon (today maybe)
Comment 16 Rex Dieter 2009-07-24 09:43:18 EDT
Looks like the html docs don't exist, and there seems to be no makefile rules to make it.  I'm ok with including the pregenerated pdf doc, if that's acceptable.
Comment 17 Rex Dieter 2009-07-24 09:48:46 EDT
nevermind, pdf isn't there either.  Looks like a dead-end for now.
Comment 18 Lorenzo Villani 2009-07-24 09:52:32 EDT
Check your IRC logs, I told you which BRs to add there some time ago ;-)
Comment 19 Lorenzo Villani 2009-07-24 09:53:14 EDT
Hint: htmldoc :-)
Comment 20 Rex Dieter 2009-07-24 10:07:42 EDT
OK, pardon my ignorance, but I still don't see any Makefile rules referencing or using it.  Am I suppose to run it by hand?
Comment 21 Lorenzo Villani 2009-07-24 10:15:11 EDT
I just had to add a BuildRequires: htmldoc here
Comment 22 Rex Dieter 2009-07-24 11:31:08 EDT
Ah,

Spec URL:
http://rdieter.fedorapeople.org/rpms/virtuoso-opensource/virtuoso-opensource.spec
SRPM URL: http://rdieter.fedorapeople.org/rpms/virtuoso-opensource/virtuoso-opensource-5.0.11-3.fc11.src.rpm

%changelog
* Fri Jul 24 2009 Rex Dieter <rdieter@fedoraproject.org> 5.0.11-3
- BR: htmldoc
- -doc subpkg
Comment 23 Lorenzo Villani 2009-07-25 13:34:17 EDT
Looks good, ship it!
Comment 24 Rex Dieter 2009-07-25 13:42:33 EDT
New Package CVS Request
=======================
Package Name: virtuoso-opensource
Short Description: A high-performance object-relational SQL database
Owners: rdieter
Branches: F-10 F-11
InitialCC:
Comment 25 Kevin Fenzi 2009-07-26 15:41:08 EDT
Humm... Lorenzo: I don't see you in the packager group. 
Is your account lvillani? Are you a packager? 

Only packagers can officially approve reviews... of course anyone is welcome to comment.
Comment 26 Kevin Kofler 2009-07-26 16:00:55 EDT
Lorenzo's FAS account is "arbiter".
Comment 27 Kevin Fenzi 2009-07-26 16:07:06 EDT
Ah, excellent. Sorry for any confusion here. 

cvs done.
Comment 28 Rex Dieter 2009-07-26 16:34:35 EDT
imported, builds coming soon.
Comment 29 Fedora Update System 2009-07-29 12:32:44 EDT
virtuoso-opensource-5.0.11-3.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/virtuoso-opensource-5.0.11-3.fc11
Comment 30 Fedora Update System 2009-07-29 12:33:07 EDT
virtuoso-opensource-5.0.11-3.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/virtuoso-opensource-5.0.11-3.fc10
Comment 31 Fedora Update System 2009-08-17 17:59:36 EDT
virtuoso-opensource-5.0.11-3.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 32 Fedora Update System 2009-08-17 18:05:28 EDT
virtuoso-opensource-5.0.11-3.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 33 Rex Dieter 2011-01-11 14:25:34 EST
Package Change Request
======================
Package Name: virtuoso-opensource
New Branches: el5 el6
Owners: rdieter
InitialCC:
Comment 34 Jason Tibbitts 2011-01-13 12:21:20 EST
Git done (by process-git-requests).

Note You need to log in before you can comment on or make changes to this bug.